"use strict";
var Promise = require("bluebird");
var fs = require('fs');
var JsonFileManager = (function () {
    function JsonFileManager() {
    }
    JsonFileManager.SaveTinderConfigAsync = function (configData, path) {
        return JsonFileManager.SaveJsonAsync(configData, path);
    };
    JsonFileManager.SaveJsonAsync = function (object, path) {
        var writeFile = Promise.promisify(fs.writeFile);
        return writeFile(path, JSON.stringify(object, null, 4))
            .then(function () {
            console.log("JSON written to " + path);
        });
    };
    JsonFileManager.LoadTinderConfigAsync = function (path) {
        return JsonFileManager.LoadJsonAsync(path);
    };
    JsonFileManager.UpdateTinderConfigAsync = function (updatedConfSection, path) {
        return JsonFileManager.LoadTinderConfigAsync(path)
            .then(function (config) {
            config.forEach(function (oldSection, idx) {
                if (oldSection.user === updatedConfSection.user) {
                    config[idx] = updatedConfSection;
                }
            });
            return JsonFileManager.SaveTinderConfigAsync(config, path);
        });
    };
    JsonFileManager.LoadJsonAsync = function (path) {
        var readFile = Promise.promisify(require("fs").readFile);
        return readFile(path, 'utf8').then(function (contents) {
            return JSON.parse(contents);
        });
    };
    return JsonFileManager;
}());
exports.JsonFileManager = JsonFileManager;
//# sourceMappingURL=jsonFileManagerAsync.js.map