"use strict";
var tinderBotAsync_1 = require("./tinderBotAsync");
var jsonFileManagerAsync_1 = require('./jsonFileManagerAsync');
var Promise = require("bluebird");
var path = require('path');
Promise.config({
    warnings: true,
    longStackTraces: true,
    cancellation: false,
    monitoring: false
});
// process.on("unhandledRejection", function (reason, promise) {
//     debugger;
//     // Todo: unhandled scenario
// });
var configPath = path.resolve('./config.json');
jsonFileManagerAsync_1.JsonFileManager.LoadTinderConfigAsync(configPath).then(function (config) {
    Startup.main(config);
});
var Startup = (function () {
    function Startup() {
    }
    Startup.main = function (config) {
        if (!config || !config.length) {
            throw new Error('config.json is invalid or empty');
        }
        var workers = [];
        Promise.resolve(config).each(function (section) {
            var runBotInstance = function (section) {
                var bot = new tinderBotAsync_1.TinderBot(section);
                var worker = bot.Run()
                    .then(function () {
                    // Never ever supposed to happen (even on errors), reject it. The global handler will catch this.
                    debugger;
                    return Promise.reject(new Error('The infinite loop somehow ended without producing an error, unexpected behavior'));
                })
                    .catch(function (err) {
                    // When out of likes / server timeouts / api or connection error
                    setTimeout(function () {
                        console.log(bot.Configuration.user);
                        runBotInstance(bot.Configuration);
                    }, section.cooldownPeriodAfterError);
                });
                workers.push(worker);
            };
            runBotInstance(section);
            return Promise.delay(5000); // Start bot instances sequentially with a delay to not trigger rate limiter
        });
        Promise.all(workers);
        return 0;
    };
    return Startup;
}());
//# sourceMappingURL=start.js.map